﻿Public Class Form1

    Dim asc_img As Image, desc_image As Image
    Dim flag As [Boolean]
    Dim cs As C1.Win.C1FlexGrid.CellStyle

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'C1NWindDataSet.Employees' table. You can move, or remove it, as needed.
        Me.EmployeesTableAdapter.Fill(Me.C1NWindDataSet.Employees)

        asc_img = Me.C1FlexGrid1.Glyphs(C1.Win.C1FlexGrid.GlyphEnum.Ascending)
        desc_image = Me.C1FlexGrid1.Glyphs(C1.Win.C1FlexGrid.GlyphEnum.Descending)

        'set transposed datatable as grid's datasource
        Me.C1FlexGrid1.DataSource = TransposeTable(Me.C1NWindDataSet.Employees)

        'Create a custom style for frozen rows/cols
        cs = Me.C1FlexGrid1.Styles.Add("Custom", Me.C1FlexGrid1.Styles.Frozen)
        cs.BackColor = Me.C1FlexGrid1.Styles.Fixed.BackColor
        cs.Border.Style = C1.Win.C1FlexGrid.BorderStyleEnum.Raised

        UpdateRowColSettings()
    End Sub

    Private Sub C1FlexGrid1_MouseUp(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles C1FlexGrid1.MouseUp

        Dim hittest = Me.C1FlexGrid1.HitTest(e.Location)

        Dim row As Integer = hittest.Row
        Dim col As Integer = hittest.Column

        If col = 0 AndAlso row <> 0 Then
            Me.C1FlexGrid1.BeginUpdate()

            Dim colname As String = Me.C1FlexGrid1(row, col).ToString()
            Dim sort As String = Me.C1NWindDataSet.Employees.DefaultView.Sort

            If sort = "" Then
                sort = colname & " ASC"
                flag = True
            Else
                If sort = colname & " ASC" Then
                    sort = colname & " DESC"
                    flag = False
                Else
                    sort = colname & " ASC"
                    flag = True
                End If
            End If

            Me.C1NWindDataSet.Employees.DefaultView.Sort = sort

            'reset grid's datasource and set Sorted DataView as grid's DataSource
            Me.C1FlexGrid1.DataSource = TransposeTable(Me.C1NWindDataSet.Employees.DefaultView.ToTable())

            'Update Fixed Rows/Cols
            UpdateRowColSettings()

            'Update and Display SortGylphs
            If flag Then
                Me.C1FlexGrid1.SetCellImage(row, col, asc_img)
            Else
                Me.C1FlexGrid1.SetCellImage(row, col, desc_image)
            End If

            'Set current Row
            Me.C1FlexGrid1.Row = row
            Me.C1FlexGrid1.EndUpdate()
        End If
    End Sub

    Private Sub UpdateRowColSettings()
        Me.c1FlexGrid1.Cols.Fixed = 0
        Me.c1FlexGrid1.Rows.Fixed = 0
        Me.c1FlexGrid1.Rows.InsertNode(0, -1)
        Me.c1FlexGrid1.Cols.Frozen = 1
        Me.c1FlexGrid1.Rows.Frozen = 1
        Me.c1FlexGrid1.Rows(0).Style = Me.c1FlexGrid1.Styles("Custom")
        Me.c1FlexGrid1.Cols(0).Style = Me.c1FlexGrid1.Styles("Custom")
        Me.c1FlexGrid1.Cols(0).AllowEditing = False
        Me.c1FlexGrid1.Rows(0).AllowEditing = False
        Me.c1FlexGrid1.Cols(0).ImageAlign = C1.Win.C1FlexGrid.ImageAlignEnum.RightCenter
        Me.c1FlexGrid1.AutoSizeCol(0)
    End Sub

    'return transposed datatable
    Private Function TransposeTable(table As DataTable) As DataTable
        Dim outputTable As New DataTable()
        outputTable.Columns.Add(table.Columns(0).ColumnName.ToString())
        For Each inRow As DataRow In table.Rows
            Dim newColName As String = inRow(0).ToString()
            outputTable.Columns.Add(newColName)
        Next
        For rCount As Integer = 0 To table.Columns.Count - 1
            Dim newRow As DataRow = outputTable.NewRow()
            newRow(0) = table.Columns(rCount).ColumnName.ToString()
            For cCount As Integer = 0 To table.Rows.Count - 1
                Dim colValue As String = table.Rows(cCount)(rCount).ToString()
                newRow(cCount + 1) = colValue
            Next
            outputTable.Rows.Add(newRow)
        Next
        Return outputTable
    End Function

  
End Class
